#include "co.hpp"

using namespace h2ococo2forcefields;

Co::Co(
      double const rc[], double const ro[], double const rx[], 
      double fc[], double fo[], double fx[], const bool fixed
) :
      rc_(rc),
      ro_(ro),
      rx_(rx),
      fc_(fc),
      fo_(fo),
      fx_(fx),
      fixed_(fixed)
{}


Co::Co(const Co & co, double fc[], double fo[], double fx[]) :
      rc_(co.rc_),
      ro_(co.ro_),
      rx_(co.rx_),
      fc_(fc),
      fo_(fo),
      fx_(fx),
      fixed_(co.fixed_)  
{
    for(int i=2;i>=0;--i) d_[i] = co.d_[i];
    d_1_ = co.d_1_;
}


void Co::incrementForces(Co const & co)
{
      for (int i=2; i >= 0; --i) {
            fc_[i]+=co.fc_[i];
            fo_[i]+=co.fo_[i];
            fx_[i]+=co.fx_[i];
      }
}

void Co::setD(const double * const d, const double & d1) {
    for(int i=2;i>=0;--i) d_[i] = d[i];
    d_1_ = d1;
}

void Co::resetForces() {
    for(int i=2;i>=0;--i) {
        fc_[i]=0.0;
        fo_[i]=0.0;
        fx_[i]=0.0;
    
    }
}
