#ifndef H2OCOCO2_CO_HPP
#define H2OCOCO2_CO_HPP

#include "helper_functions.hpp"

namespace h2ococo2forcefields {

class Co {
    public:
        Co( double const rc[], double const ro[], double const rx[], 
            double fc[], double fo[], double fx[], const bool fixed);


        Co(const Co & co, double fc[], double fo[], double fx[]);
        void incrementForces(Co const & co);
                  
        const double * const rc_;///< position of C
        const double * const ro_;///< position of O
        const double * const rx_;///< position of centre of mass.
        double * const fc_;///< force on C
        double * const fo_;///< force on O
        double * const fx_;///< Force on charge X.

        const bool fixed_;

        double d_[3];
        double d_1_;

        void setD(const double * const d, const double & d1);
        void resetForces();

};   


}

#endif
