#include "co2.hpp"
#include <iostream>
using namespace h2ococo2forcefields;

Co2::Co2(double const rc[], double const ro1[], double const ro2[], double const rx[],
                        double fc[], double fo1[], double fo2[], double fx[], const bool fixed) :
                        rc_(rc),
                        ro1_(ro1),
                        ro2_(ro2),
                        rx_(rx),
                        fc_(fc),
                        fo1_(fo1),
                        fo2_(fo2),
                        fx_(fx),
                        fixed_(fixed)
{}        
                         

Co2::Co2(const Co2 & co2, double fc[], double fo1[], double fo2[], double fx[]) :
    rc_(co2.rc_),
    ro1_(co2.ro1_),
    ro2_(co2.ro2_),
    rx_(co2.rx_),
    fc_(fc),
    fo1_(fo1),
    fo2_(fo2),
    fx_(fx),
    fixed_(co2.fixed_)
{
}

void Co2::incrementForces(Co2 const & co2) 
{
    for(int i=2; i>=0; --i) {
        fc_[i] +=co2.fc_[i];
        fo1_[i]+=co2.fo1_[i];
        fo2_[i]+=co2.fo2_[i];
        fx_[i] +=co2.fx_[i];
    }
}


void Co2::setD(const double * const d1, const double * const d2, const double & d1_1,const double & d2_1) {
    for(int i=2;i>=0;--i) {
        d1_[i] = d1[i];
        d2_[i] = d2[i];
    }
    d1_1_ = d1_1;
    d2_1_ = d2_1;
}

void Co2::resetForces() {
    for(int i=2;i>=0;--i) {
        fc_[i]  =0.0;
        fo1_[i] =0.0;
        fo2_[i] =0.0;
        fx_[i]  =0.0;
    }
}
