#ifndef H2OCOCO2_CO2_HPP
#define H2OCOCO2_CO2_HPP

#include "helper_functions.hpp"
#include <iostream>
namespace h2ococo2forcefields{

class Co2 {
    public:
    //constructors
        Co2(double const rc[], double const ro1[], double const ro2[], double const rx[],
            double fc[], double fo1[], double fo2[], double fx[], const bool fixed );
        Co2(const Co2 & co2, double fc[], double fo1[], double fo2[], double fx[]);
           

        void incrementForces(Co2 const & co2);


        const double * const    rc_; ///< position of C;
        const double * const    ro1_;///< position of O1;
        const double * const    ro2_;///< position of O2;
        const double * const    rx_;///< position of the center of mass

        const bool fixed_;

        double * const fc_;  ///< force on C
        double * const fo1_;///< force on O1
        double * const fo2_;///< force on O2
        double * const fx_; ///< force on the center of mass

        double d1_[3];  //ro1-rc
        double d2_[3];  //ro2-rc
        double d1_1_;
        double d2_1_;

        void setD(const double * const d1, const double * const d2, const double & d1_1,const double & d2_1);
        void resetForces();

};
}

#endif
