#ifndef H2OCOCO2FORCEFIELDS_CO2CO2_HPP
#define H2OCOCO2FORCEFIELDS_CO2CO2_HPP

#include "potential_base.hpp"

namespace h2ococo2forcefields {
	class Co2Co2 : virtual public h2ococo2forcefields::PotentialBase {

    public:
        //constructor
        Co2Co2();
        //destructor
        ~Co2Co2() {};
        static char const * getName();///< Name of the potential.
        void computeCO2_CO2(const int nCo2, Co2 *const *const co2List, double &energy, const double* const diagbox);
        void computeCO2Intra(const int nCo2, Co2 *const *const co2List, double & energy, const double* const diagbox);        
        void computeInterMolecularCo2Co2(Co2 &co21, Co2 &co22, double &energy,double *force,const double* const diagbox);
    protected:
        void calculateInternalGeometry(Co2 &co2);
    private:
        void intraMolecular(Co2& co2, double &energy);
        void interMolecular(Co2 &co2_1, Co2 &co2_2, double &energy);
        const double qcqc;
        const double qcqo;
        const double qoqo;

    };
}
#endif
