#ifndef H2OCOCO2FORCEFIELDS_H2OCO2_HPP
#define H2OCOCO2FORCEFIELDS_H2OCO2_HPP

#include "potential_base.hpp"

namespace h2ococo2forcefields {
	class H2oCo2 : virtual public h2ococo2forcefields::PotentialBase {

    public:
        //constructor
        H2oCo2();
        //destructor
        ~H2oCo2() {};
        static char const * getName();///< Name of the potential.
        void computeH2O_CO2(const int nH2o, const int nCo2, Water *const *const h2oList, Co2 *const *const co2List, double &energy, const double* const diagbox);
        void computeInterMolecularH2oCo2(Water &w, Co2 &co2, double &energy,double *force,const double* const diagbox);
        
    private:
        const double qmqc;
        const double qmqo;
        const double qhqc;
        const double qhqo;

        void fullInteraction(Water &w, Co2 &co2,double &energy);

    };
}
#endif
