#ifndef H2OCOCO2_MOLECULES_HPP
#define H2OCOCO2_MOLECULES_HPP

#include "potential_base.hpp"
#include "geometry.hpp"
#include "potential_parameters.hpp"
#include "water.hpp"
#include "co.hpp"
#include "co2.hpp"

namespace h2ococo2forcefields{
    
    class Molecules {

        public:
        
            Molecules(const int n_h2o,const int n_co,const int n_co2,const double * const diagbox);
            ~Molecules();

            const int nH2o;
            const int nCo;
            const int nCo2;            

            void initialize(const double* const R, double * const F, const int* const fixed,const double * const diagbox);
            void cleanUp();            

            Water**  h2oList;
            Co**     coList;
            Co2**    co2List;

        private:
            bool  cleanedUp;

            double *Rx;
            double *Fx;
            Geometry geom;

            void initializeCo(const double* const R, double* const F, const int* const fixed);
            void initializeH2o(const double* const R, double* const F, const int* const fixed);
            void initializeCo2(const double* const R, double* const F, const int* const fixed);

    };

}

#endif
