#ifndef H2OCOCO2FORCEFIELDS_TIP4P_HPP
#define H2OCOCO2FORCEFIELDS_TIP4P_HPP
#include "potential_base.hpp"


namespace h2ococo2forcefields {
    class Tip4p : virtual public PotentialBase {
public:
        Tip4p();
        Tip4p(double cutoff, double switchingWidth);
        ~Tip4p(){}
        void computeHH_O_(const int nH2o, Water *const *const h2oList, double &energy, const double* const diagbox);
        void computeH2OIntra(const int nH2o, Water *const *const h2oList, double & energy, const double* const diagbox);
        void computeInterMolecularH2oH2o(Water &w1, Water &w2, double &energy,double *force,const double* const diagbox);
        static char const * getName();
protected:
        void calculateInternalGeometry(Water & w);
        void computeIntraMolecularH2o(Water &w1, double &energy);
private:
        void coulombFull(Water & w1, Water & w2, double & U);
    };
}
#endif
