#ifndef H2OCOCO2_WATER_HPP
#define H2OCOCO2_WATER_HPP

#include "helper_functions.hpp"

namespace h2ococo2forcefields {

class Water {

    public:    

		 	 Water( double const *rh1, double const rh2[], double const ro[], double const rx[],
		 	 	    double fh1[], double fh2[], double fo[], double fx[],const bool fixed);

 
		 	 Water(const Water & w, double fh1[], double fh2[], double fo[], double fx[]);


            ~Water();   


			 const double * const rh1_;///< position of H1
			 const double * const rh2_;///< position of H2
			 const double * const ro_;///< position of O
			 const double * const rx_;///< position of c (center mass)
			 double * const fh1_;///< force on h1
			 double * const fh2_;///< force on h2
			 double * const fo_;///< force on O
             double * const fx_;///< force on c.o.m.

            const bool fixed_;

            double rm_[3];
            double fm_[3];
            double d1_[3];  //rh1-ro
            double d2_[3];  //rh2-ro
            double d1_1_;
            double d2_1_;

            void setRm(const double * const rm);  
            void setD(const double * const d1, const double * const d2, const double & d1_1,const double & d2_1);

			void incrementForces(Water const & w);		           
            void resetForces();
};
}
#endif
